package com.winhc.bigdata.spark.test

import java.util.Properties

import com.winhc.bigdata.spark.test.newPhoenixTest.{DB_PHOENIX_DRIVER, DB_PHOENIX_FETCHSIZE, DB_PHOENIX_PASS, DB_PHOENIX_URL, DB_PHOENIX_USER, SQL_QUERY}
import com.winhc.bigdata.spark.utils.SparkUtils

import scala.collection.mutable

/**
 * @Author: XuJiakai
 * @Date: 2020/6/2 16:56
 * @Description:
 */
object TestSpark2AliPhoenix {
  private val DB_PHOENIX_DRIVER = "org.apache.phoenix.queryserver.client.Driver"
  private val DB_PHOENIX_URL = "jdbc:phoenix:thin:url=http://hb-uf6as8i6h85k02092-001.hbase.rds.aliyuncs.com:8765;serialization=PROTOBUF"
  private val DB_PHOENIX_USER = ""
  private val DB_PHOENIX_PASS = ""
  private val DB_PHOENIX_FETCHSIZE = "10000"

  def main(args: Array[String]): Unit = {
    val map = mutable.Map[String, String](
      "spark.hadoop.odps.spark.local.partition.amt" -> "100"
    )
    val sparkSession = SparkUtils.InitEnv("scala spark on Phoenix5.x test", map)

    val phoenixTableName = "COMPANY_BID_LIST"
    val sparkTableName = "test_spark"

    val driver = "org.apache.phoenix.queryserver.client.Driver"
    val url = SparkUtils.PhoenixUrl

/*
    sparkSession.sql(s"drop table if exists $sparkTableName")
    val createCmd = "CREATE TABLE " +
      sparkTableName +
      " USING org.apache.spark.sql.jdbc\n" +
      "OPTIONS (\n" +
      "  'driver' '" + driver + "',\n" +
      "  'url' '" + url + "',\n" +
      "  'dbtable' '" + phoenixTableName + "',\n" +
      "  'fetchsize' '" + 100 + "'\n" +
      ")"
    println(" createCmd: \n" + createCmd)
    sparkSession.sql(createCmd)
    val querySql = "select * from " + sparkTableName + " limit 100"
    sparkSession.sql(querySql).show
*/
// JDBC连接属性
    val SQL_QUERY = " ( SELECT ID,NCID,CID,TITLE FROM COMPANY_BID_LIST limit 10 )  events  "
    val connProp = new Properties
    connProp.put("driver", DB_PHOENIX_DRIVER)
    connProp.put("user", DB_PHOENIX_USER)
    connProp.put("password", DB_PHOENIX_PASS)
    connProp.put("fetchsize", DB_PHOENIX_FETCHSIZE)
    sparkSession.read.jdbc(DB_PHOENIX_URL, SQL_QUERY, connProp).show

  }
}
